<?php

namespace Lc\ShopBundle\Form\Backend\Common;

use Doctrine\ORM\EntityManagerInterface;

use Lc\ShopBundle\Context\NewsletterInterface;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolver;

class NewslettersType extends AbstractType
{
        protected $em;
        public function __construct(EntityManagerInterface $entityManager){
                $this->em = $entityManager;
        }

        public function buildForm(FormBuilderInterface $builder, array $options)
        {
                $builder->addEventListener(FormEvents::PRE_SET_DATA, function (FormEvent $event) {
                        $builder = $event->getForm()->getParent();
                        $newsletterClass = $this->em->getClassMetadata(NewsletterInterface::class);

                        $builder->add('newsletters', EntityType::class, [
                                'class' => $newsletterClass->getName(),
                                'multiple' =>true,
                                'required' => false,
                                'merchant_filter'=> false
                        ]);
                });
        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'merchant_filter' => false
                ]);
        }
}
